# -*- coding: utf-8 -*-
#
# File: OpenSearch.py
#
# Copyright (c) 2007 by []
# Generator: ArchGenXML Version 1.5.2
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """Christian Ledermann <unknown>"""
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.plos.config import *


from Products.CMFCore.utils import UniqueObject

    
##code-section module-header #fill in your manual code here
##/code-section module-header

schema = Schema((

    TextField(
        name='description',
        read_permission="view",
        widget=TextAreaWidget(
            label="Description",
            description="A human-readable text description of the search engine",
            label_msgid='plos_label_description',
            description_msgid='plos_help_description',
            i18n_domain='plos',
        ),
        required=True,
        accessor="Description",
        write_permission="Manage Portal"
    ),

),
)

##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

OpenSearch_schema = BaseSchema.copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class OpenSearch(UniqueObject, BaseContent):
    """
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(UniqueObject,'__implements__',()),) + (getattr(BaseContent,'__implements__',()),)

    # This name appears in the 'add' box
    archetype_name = 'OpenSearch'

    meta_type = 'OpenSearch'
    portal_type = 'OpenSearch'
    allowed_content_types = []
    filter_content_types = 0
    global_allow = 0
    #content_icon = 'OpenSearch.gif'
    immediate_view = 'base_view'
    default_view = 'base_view'
    suppl_views = ()
    typeDescription = "OpenSearch"
    typeDescMsgId = 'description_edit_opensearch'
    toolicon = 'opensearch.png'


    actions =  (


       {'action': "string:${object_url}/plos-description.xml",
        'category': "object",
        'id': 'plos-description.xml',
        'name': 'OpenSearch Description',
        'permissions': ("View",),
        'condition': 'python:1'
       },


       {'action': "string:${object_url}/plos-rss.xml",
        'category': "object",
        'id': 'plos-rss.xml',
        'name': 'OpenSearch RSS Response',
        'permissions': ("View",),
        'condition': 'python:1'
       },


       {'action': "string:${object_url}/plos-atom.xml",
        'category': "object",
        'id': 'plos-atom.xml',
        'name': 'OpenSearch Atom Response',
        'permissions': ("View",),
        'condition': 'python:1'
       },


    )

    _at_rename_after_creation = True

    schema = OpenSearch_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header


    # tool-constructors have no id argument, the id is fixed
    def __init__(self, id=None):
        BaseContent.__init__(self,'portal_opensearch')
        self.setTitle('OpenSearch')
        
        ##code-section constructor-footer #fill in your manual code here
        ##/code-section constructor-footer


    # tool should not appear in portal_catalog
    def at_post_edit_script(self):
        self.unindexObject()
        
        ##code-section post-edit-method-footer #fill in your manual code here
        ##/code-section post-edit-method-footer


    # Methods


registerType(OpenSearch, PROJECTNAME)
# end of class OpenSearch

##code-section module-footer #fill in your manual code here
##/code-section module-footer



