# -*- coding: utf-8 -*-
#
# File: SearchFeed.py
#
# Copyright (c) 2007 by []
# Generator: ArchGenXML Version 1.5.2
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """Christian Ledermann <unknown>"""
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.plos.config import *

##code-section module-header #fill in your manual code here
import feedparser
##/code-section module-header

schema = Schema((

    TextField(
        name='description',
        widget=TextAreaWidget(
            description="A short description of the searchengine",
            label="Description",
            label_msgid='plos_label_description',
            description_msgid='plos_help_description',
            i18n_domain='plos',
        ),
        required=True,
        accessor="Description",
        searchable=True
    ),

    StringField(
        name='searchUrl',
        widget=StringWidget(
            label="URL of the Searchfeed",
            description="OpenSearch description style URL, replace the search input value with  {searchTerms}",
            label_msgid='plos_label_searchUrl',
            description_msgid='plos_help_searchUrl',
            i18n_domain='plos',
        ),
        required=True
    ),

),
)

##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

SearchFeed_schema = BaseSchema.copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class SearchFeed(BaseContent):
    """
    Search an OpenSearch compatible source
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseContent,'__implements__',()),)

    # This name appears in the 'add' box
    archetype_name = 'Search Feed'

    meta_type = 'SearchFeed'
    portal_type = 'SearchFeed'
    allowed_content_types = []
    filter_content_types = 0
    global_allow = 1
    content_icon = 'opensearch.png'
    immediate_view = 'base_view'
    default_view = 'base_view'
    suppl_views = ()
    typeDescription = "Search Opensearch compatible feeds"
    typeDescMsgId = 'description_edit_searchfeed'


    actions =  (


       {'action': "string:${object_url}/plos_search_view",
        'category': "object",
        'id': 'view',
        'name': 'view',
        'permissions': ("View",),
        'condition': 'python:1'
       },


    )

    _at_rename_after_creation = True

    schema = SearchFeed_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header

    # Methods
    security.declarePublic('plos_feedurl')
    def plos_feedurl(self,searchTerm):
        """
        return the URL for the search
        """
        OSUrl=self.searchUrl
        OSUrl = OSUrl.replace('{searchTerms}',searchTerm)
        return OSUrl 
        
    security.declarePublic('getOpenSearchFeed')
    def getOpenSearchFeed(self,searchTerm):
        """
        get the searchresults from an external feed (defined with the searchURL)
        """
        if not searchTerm:
                return None

        OSUrl=self.searchUrl
        OSUrl = OSUrl.replace('{searchTerms}',searchTerm)
        osResults= feedparser.parse(OSUrl)
        return osResults['entries']




registerType(SearchFeed, PROJECTNAME)
# end of class SearchFeed

##code-section module-footer #fill in your manual code here
##/code-section module-footer



